<?php
/*********************************************
 cpgShop Plugin for Coppermine Photo Gallery
 ********************************************
 written by Thomas Lange
 based on cpgmart by foulu

 ********************************************
 * @file $Id: cpgTool.class.php 44 2010-11-11 18:39:33Z Stramm $
 * @author $Author: Stramm $
 * @version $Revision: 44 $
 * @lastrevision $Date: 2010-11-11 19:39:33 +0100 (Do, 11 Nov 2010) $
 * @modifiedby $LastChangedBy: Stramm $
 * @lastmodified $LastChangedDate: 2010-11-11 19:39:33 +0100 (Do, 11 Nov 2010) $
 ********************************************
 cpgShop full Version 1.0.1
 **********************************************/


class cpgTool {
	//is shop enabled
	function check_enabled(){
		global  $lang_cs_error, $CONFIG;

		if (!$CONFIG['cpgshop_enable']) {
			cpg_die(ERROR, $lang_cs_error['enabled'], __FILE__, __LINE__);
		}
		return;
	}
	//is user logged in
	function check_user(){
		global  $lang_cs_error, $REFERER;

		if (!USER_ID) {
			cpg_die(ERROR, sprintf($lang_cs_error['login'], $REFERER), __FILE__, __LINE__);
		}
		return;
	}
	//is the cart not empty
	function check_cart($cpgshop){
		global  $lang_cs_error, $CONFIG;

		$item_in_cart = count($cpgshop->cart);
		if ($item_in_cart == 0) {
			cpg_die(ERROR, $lang_cs_error['no_item'], __FILE__, __LINE__);
		}
		return;
	}
	//check min order value
	function check_min_order($cpgshop){
		global $lang_cs_error, $CONFIG;

		if ($CONFIG['cpgshop_min_order_enable']) {
			if(self::price_all($cpgshop->cart) < $CONFIG['cpgshop_min_order']){
				cpg_die(ERROR, $lang_cs_error['min_order'], __FILE__, __LINE__);
			}
		}
		return;
	}


	//returns an array with the required fields of the profile - see english.php
	function required_fields(){
		global $lang_cs_profile, $lang_register_php;
		$warning=false;
		$required = array();
		foreach($lang_cs_profile as $key => $value){
			$string=$key.'_warning1';
			if (array_key_exists($string,$lang_register_php)) {
				$required[$key] = 1;
			}
		}
		return $required;
}
	// _REQUEST VAR
	//outdated cause of inspekt
	function request_var($var_name) {
		if (cpgTool::post_var($var_name) == false) {
			$return = cpgTool::get_var($var_name);
		} else {
			$return = cpgTool::post_var($var_name);
		}
		return $return;
	}
	// _GET VAR
	function get_var($var_name) {
		$get_var = '';
		$superCage = Inspekt::makeSuperCage();
		if ($superCage->get->keyExists($var_name)) {
			$get_var = $superCage->get->getEscaped($var_name);
		}

		if (!$get_var) {
			return false;
		} else {
			return $get_var;
		}
		return false;
	}
	// _POST VAR
	function post_var($var_name, $type='getEscaped') {
		$post_var = '';
		$superCage = Inspekt::makeSuperCage();
		if ($superCage->post->keyExists($var_name)) {
			switch($type){
				case('getAlnum'):
					$post_var = $superCage->post->getAlnum($var_name);
				break;
				case('getAlpha'):
					$post_var = $superCage->post->getAlpha($var_name);
					break;
				case('getDigits'):
					$post_var = $superCage->post->getDigits($var_name);
					break;
				case('getDir'):
					$post_var = $superCage->post->getDir($var_name);
					break;
				case('getInt'):
					$post_var = $superCage->post->getInt($var_name);
					break;
				case('getPath'):
					$post_var = $superCage->post->getPath($var_name);
					break;
				case('getRaw'):
					$post_var = $superCage->post->getRaw($var_name);
					break;
				case('noPath'):
					$post_var = $superCage->post->noPath($var_name);
					break;
				case('noTags'):
					$post_var = $superCage->post->noTags($var_name);
					break;
				default:
					$post_var = $superCage->post->getEscaped($var_name);
			}
		}

		if (!$post_var) {
			return false;
		} else {
			return $post_var;
		}
		return false;
	}
	//billing address... either from users table or shops address table if bridged
	function get_user_info($uid=false){
		global $CONFIG;

		if(!$uid)  $uid = USER_ID;

		if (UDB_INTEGRATION == 'coppermine') {
			$user_data = cpgDB::fetchRow("SELECT title, surename, lastname, street, city, zip, state, phone, country FROM {$CONFIG['TABLE_USERS']}  WHERE user_id ='" . $uid . "' ");
		} else {
			$user_data = cpgDB::fetchRow("SELECT sid, title, surename, lastname, street, city, zip, state, phone, country FROM {$CONFIG['TABLE_CS_ADDRESS']}  WHERE type ='0'  AND user_id ='" . $uid . "' ");
		}
		return $user_data;
	}
	// format to cool format
	function price_format($price) {
		return number_format($price, 2, '.', '');
	}
	// exchange price beetween different currecy
	function currency_exchange($price, $from, $to) {
		global $CONFIG;
		return $price*(self::currency_rate($to)/self::currency_rate($from));
	}
	// to config currency
	function to_config_currency($price, $currency) {
		global $CONFIG;
		return self::currency_exchange($price, $currency, $CONFIG['cpgshop_currency']);
	}
	// check if this pic is shopable || not
	function is_shopable($pic_data) {
		global $CONFIG;
		// pid || pic_data
		if (!is_array($pic_data)) $pic_data = array('pid'=>$pic_data);
		// empty -> get from DB ^^
		if (!isset($pic_data['price']))
			$pic_data['price'] = cpgDB::fetchVar("SELECT price FROM `{$CONFIG['TABLE_PICTURES']}` WHERE pid = '{$pic_data['pid']}' LIMIT 1;");
		// check & return
		if ((int)$pic_data['price'] == 0) return false; else return true;

	}
	// encode
	function encode_data($data) {
		return base64_encode(serialize($data));
	}
	// decode
	function decode_data($data) {
		return unserialize(base64_decode($data));
	}
	function add_js($file_or_content) {
		global $CONFIG;
		global $template_header;

		// file || content
		if (is_file($fileORcontent))
			$js_include = "<script type=\"text/javascript\" src=\"$file_or_content\"></script>";
		else
			$js_include = $file_or_content;
		// add
		$template_header = str_replace("</head>",$js_include."\n</head>",$template_header);
		return $template_header;
	}
	function error($errorString) {
		echo $errorString;
		exit;
	}
	function in_string($string, $search_string) {
		if (strpos($string, $search_string) !== false) return true;
		else return false;
	}
	function get_pic_data($pid) {
		global $CONFIG;
		return cpgDB::fetchRow("SELECT pid, url_prefix, filepath, filename, pwidth, pheight, `price`, `option` FROM `{$CONFIG['TABLE_PICTURES']}` WHERE pid='$pid' LIMIT 1;");
	}
	//returns 0 shipping item, 1 download
	function shipping_item($item_data) {
		global $CONFIG;
		$current_type_data = cpgDB::fetchRow("SELECT type FROM `{$CONFIG['TABLE_CS_PRICE']}` WHERE pid='{$item_data}' LIMIT 1;");
		return $current_type_data['type'];
	}
	//grabs the billing address from the db or uses the user_data parameter and checks if all's good, returns html and display msg_box
	function verify_billingshipping_info($msg='billing', $user_data=false){
		global $CONFIG, $lang_cs_profile, $lang_cs_cart;

		$html = '';
		if(!$user_data){
			return false;
		}
		$required = cpgTool::required_fields();

		foreach($user_data as $key => $data){
			if ($key == 'country') {
				$data = cpgTool::country_by_code($data);
			}

			if ($key == 'title') {
				$data = $lang_cs_profile["$data"];
			}

			//we don't want to display the db id
			if($key != 'sid'){
				//add the * to the required info form field title
				if(!$data && $required[$key]==1){
					$warning=true;
					$html .= "<tr><td width=\"40%\">{$lang_cs_profile[$key]}</td><td class=\"warning\">{$lang_cs_cart['info_missing']}</td></tr>\n";
				} else {
					$html .= "<tr><td width=\"40%\">{$lang_cs_profile[$key]}</td><td>$data</td></tr>\n";
				}
			}
		}

		if ($warning && $msg=='billing') {
			msg_box($lang_cs_cart['warning'], $lang_cs_cart['warning_txt'], "<span class=\"button button_normalfont\">".$lang_cs_cart['warning_button']."</span>","index.php?file=cpgshop/cpgshop_cart&page=edit_address&type=0", 'warning');
		} elseif(!$warning && $msg=='billing') {
			msg_box($lang_cs_cart['OK'], $lang_cs_cart['OK_txt'],"<span class=\"button button_normalfont\">".$lang_cs_cart['OK_button']."</span>","index.php?file=cpgshop/cpgshop_cart&page=edit_address&type=0", 'success');
		} elseif ($warning && $msg=='shipping') {
			msg_box($lang_cs_cart['warning'], $lang_cs_cart['warning_ship_txt'], "<span class=\"button button_normalfont\">".$lang_cs_cart['warning_ship_button']."</span>","index.php?file=cpgshop/cpgshop_cart&page=edit_address&type=1", 'warning');
		}
		return $html;
	}
	//checks the users billing and shipping address, returns an array with values of billing, shipping and country if there is a problem
	function verify_address($delivery_mode){
		global $CONFIG;
		//verify valid info for the verify address form
		//1. if shipping: billing and shipping address are valid
		//2. if download: billing address is valid
		//get the users profile data and check if all fields are filled in, display a message
		$user_data = self::get_user_info(USER_ID);
		$required = self::required_fields();
		foreach($user_data as $key => $data){
			if ($key == 'country') {
				$data = self::country_by_code($data);
			}
			if(!$data && $required[$key]==1){
				$message[] = 'adr_billing_error';
			}
		}
		//now check shipping if needed... and especially the dest country
		if($delivery_mode){
			$shipping_data = cpgDB::fetchRow("SELECT sid, surename, lastname, street, city, zip, state, country FROM {$CONFIG['TABLE_CS_ADDRESS']}  WHERE user_id ='" . USER_ID . "' ");

			//get the shipping address, if no is set, shipping address = billing address
			if(!isset($shipping_data['sid'])){
				//no shipping address set: check if valid destination country in billing
				$shipping_data = $user_data;
			}
			foreach($shipping_data as $key => $data){
				if ($key == 'country') {
					$data = self::country_by_code($data);
					//now get the countries to ship to and the shipping prices (shop config)
					$country_to = cpgDB::fetchRow("SELECT cid FROM {$CONFIG['TABLE_CS_COUNTRY']}  WHERE abbr ='" . $shipping_data['country'] . "';");
					//if the shipping address country is not in the to_ship country table, display a warning
					if(!$country_to['cid']){
						$message[] = 'adr_country_error';
					}
				}

				if($key != 'sid'){
					if(!$data && $required[$key]==1){
						$message[] = 'adr_shipping_error';
					}
				}
			}
		} // end check verify_address form data
		return $message;
	}
	//returns the total price for an item (incl. options)
	function price_each($item_data) {
		global $CONFIG;
		$total = 0;
		// get price value
		$current_price_data = cpgDB::fetchRow("SELECT value, currency FROM `{$CONFIG['TABLE_CS_PRICE']}` WHERE pid='{$item_data['price']}' LIMIT 1;");
		$total += self::to_config_currency($current_price_data['value'], $current_price_data['currency']);

		// get option value
		$option_set = cpgDB::fetchRow("SELECT * FROM `{$CONFIG['TABLE_CS_OPTIONSET']}` WHERE oid = '$optionset_id' LIMIT 1;");
		$option_array = cpgTool::decode_data($option_set['option_array']);

		foreach($item_data['option'] as $option_id => $onumber) {
			$option_data = cpgDB::fetchRow("SELECT title, title_array, value_array, currency FROM `{$CONFIG['TABLE_CS_OPTION']}` WHERE oid = '$option_id' LIMIT 1;");

			$option_data['title_array']	= cpgTool::decode_data($option_data['title_array']);
			$option_data['value_array']	= cpgTool::decode_data($option_data['value_array']);

			$total += self::to_config_currency($option_data['value_array'][$onumber], $CONFIG['cpgshop_currency']);
		}
		return $total;
	}
	//returns the total price in basket
	function price_all($cpgshop){
		$total = 0;
		foreach ($cpgshop as $item_pos => $item_data) {
			$CURRENT_PIC_DATA = cpgTool::get_pic_data($item_data['pid']);
			$price_each = cpgTool::price_each($item_data);
			$total += $price_each * $item_data['qty'];
		}
		return $total;
	}
	//returns the options array for an image
	function get_option_array_from_pid($pid) {
		global $CONFIG;
		$row = cpgDB::fetchRow("SELECT `option` FROM `{$CONFIG['TABLE_PICTURES']}` WHERE pid='$pid' LIMIT 1;");
		$option_set_id = $row['option'];

		$row = cpgDB::fetchRow("SELECT `option_array` FROM `{$CONFIG['TABLE_CS_OPTIONSET']}` WHERE oid='$option_set_id' LIMIT 1;");
		$option_array =$row['option_array'];

		return self::decode_data($option_array);
	}
	function currency_rate($currency) {
		$exc_rate = array(
			'USD' => 1,
			'CAD' => 0.99597997037873,
			'GBP' => 0.4914309894915,
			'EUR' => 0.70526835460893,
			'JPY' => 115.34663939629,
		);
		return $exc_rate[$currency];
	}
	//create country array
	function countries()
	{
		$countries = array(
		"" => "",
		"af" => "Afghanistan",
		"al" => "Albania",
		"dz" => "Algeria",
		"as" => "American Samoa",
		"ad" => "Andorra",
		"ao" => "Angola",
		"ai" => "Anguilla",
		"aq" => "Antarctica",
		"ag" => "Antigua and Barbuda",
		"ar" => "Argentina",
		"am" => "Armenia",
		"aw" => "Aruba",
		"ac" => "Ascension Island",
		"au" => "Australia",
		"at" => "Austria",
		"az" => "Azerbaijan",
		"bs" => "Bahamas",
		"bh" => "Bahrain",
		"bd" => "Bangladesh",
		"bb" => "Barbados",
		"by" => "Belarus",
		"be" => "Belgium",
		"bz" => "Belize",
		"bj" => "Benin",
		"bm" => "Bermuda",
		"bt" => "Bhutan",
		"bo" => "Bolivia",
		"ba" => "Bosnia and Herzegovina",
		"bw" => "Botswana",
		"bv" => "Bouvet Island",
		"br" => "Brazil",
		"io" => "British Indian Ocean Territory",
		"bn" => "Brunei Darussalam",
		"bg" => "Bulgaria",
		"bf" => "Burkina Faso",
		"bi" => "Burundi",
		"kh" => "Cambodia",
		"cm" => "Cameroon",
		"ca" => "Canada",
		"cv" => "Cape Verde",
		"ky" => "Cayman Islands",
		"cf" => "Central African Republic",
		"td" => "Chad",
		"cl" => "Chile",
		"cn" => "China",
		"cx" => "Christmas Island",
		"cc" => "Cocos (Keeling Islands)",
		"co" => "Colombia",
		"km" => "Comoros",
		"cg" => "Congo",
		"ck" => "Cook Islands",
		"cr" => "Costa Rica",
		"ci" => "Cote'Ivoire (Ivory Coast)",
		"hr" => "Croatia (Hrvatska)",
		"cu" => "Cuba",
		"cy" => "Cyprus",
		"cz" => "Czech Republic",
		"dk" => "Denmark",
		"dj" => "Djibouti",
		"dm" => "Dominica",
		"do" => "Dominican Republic",
		"tp" => "East Timor",
		"ec" => "Ecuador",
		"eg" => "Egypt",
		"sv" => "El Salvador",
		"gq" => "Equatorial Guinea",
		"er" => "Eritrea",
		"ee" => "Estonia",
		"et" => "Ethiopia",
		"fk" => "Falkland Islands (Malvinas)",
		"fo" => "Faroe Islands",
		"fj" => "Fiji",
		"fi" => "Finland",
		"fr" => "France",
		"fx" => "France, Metropolitan",
		"gf" => "French Guiana",
		"pf" => "French Polynesia",
		"tf" => "French Southern Territories",
		"ga" => "Gabon",
		"gm" => "Gambia",
		"ge" => "Georgia",
		"de" => "Germany",
		"gh" => "Ghana",
		"gi" => "Gibraltar",
		"gr" => "Greece",
		"gl" => "Greenland",
		"gd" => "Grenada",
		"gp" => "Guadeloupe",
		"gu" => "Guam",
		"gt" => "Guatemala",
		"gg" => "Guernsey",
		"gn" => "Guinea",
		"gw" => "Guinea-Bissau",
		"gy" => "Guyana",
		"ht" => "Haiti",
		"hm" => "Heard and McDonald Islands",
		"hn" => "Honduras",
		"hk" => "Hong Kong",
		"hu" => "Hungary",
		"is" => "Iceland",
		"in" => "India",
		"id" => "Indonesia",
		"ir" => "Iran",
		"iq" => "Iraq",
		"ie" => "Ireland",
		"im" => "Isle of Man",
		"il" => "Israel",
		"it" => "Italy",
		"jm" => "Jamaica",
		"jp" => "Japan",
		"je" => "Jersey",
		"jo" => "Jordan",
		"kz" => "Kazakhstan",
		"ke" => "Kenya",
		"ki" => "Kiribati",
		"kp" => "Korea (North)",
		"kr" => "Korea (South)",
		"kw" => "Kuwait",
		"kg" => "Kyrgyzstan",
		"la" => "Laos",
		"lv" => "Latvia",
		"lb" => "Lebanon",
		"ls" => "Lesotho",
		"lr" => "Liberia",
		"ly" => "Libya",
		"li" => "Liechtenstein",
		"lt" => "Lithuania",
		"lu" => "Luxembourg",
		"mo" => "Macau",
		"mk" => "Macedonia",
		"mg" => "Madagascar",
		"mw" => "Malawi",
		"my" => "Malaysia",
		"mv" => "Maldives",
		"ml" => "Mali",
		"mt" => "Malta",
		"mh" => "Marshall Islands",
		"mq" => "Martinique",
		"mr" => "Mauritania",
		"mu" => "Mauritius",
		"yt" => "Mayotte",
		"mx" => "Mexico",
		"fm" => "Micronesia",
		"md" => "Moldova",
		"mc" => "Monaco",
		"mn" => "Mongolia",
		"me" => "Montenegro",
		"ms" => "Montserrat",
		"ma" => "Morocco",
		"mz" => "Mozambique",
		"mm" => "Myanmar",
		"na" => "Namibia",
		"nr" => "Nauru",
		"np" => "Nepal",
		"nl" => "Netherlands, The",
		"an" => "Netherlands Antilles",
		"nc" => "New Caledonia",
		"nz" => "New Zealand",
		"ni" => "Nicaragua",
		"ne" => "Niger",
		"ng" => "Nigeria",
		"nu" => "Niue",
		"nf" => "Norfolk Island",
		"mp" => "Northern Mariana Islands",
		"no" => "Norway",
		"om" => "Oman",
		"pk" => "Pakistan",
		"pw" => "Palau",
		"pa" => "Panama",
		"pg" => "Papua New Guinea",
		"py" => "Paraguay",
		"pe" => "Peru",
		"ph" => "Philippines",
		"pn" => "Pitcairn",
		"pl" => "Poland",
		"pt" => "Portugal",
		"pr" => "Puerto Rico",
		"qa" => "Qatar",
		"re" => "Reunion",
		"ro" => "Romania",
		"rs" => "Serbia",
		"ru" => "Russian Federation",
		"rw" => "Rwanda",
		"gs" => "S. Georgia and S. Sandwich Isls.",
		"kn" => "Saint Kitts and Nevis",
		"lc" => "Saint Lucia",
		"vc" => "Saint Vincent and The Grenadines",
		"ws" => "Samoa",
		"sm" => "San Marino",
		"st" => "Sao Tome and Principe",
		"sa" => "Saudi Arabia",
		"sn" => "Senegal",
		"sc" => "Seychelles",
		"sl" => "Sierra Leone",
		"sg" => "Singapore",
		"sk" => "Slovak Republic",
		"si" => "Slovenia",
		"sb" => "Solomon Islands",
		"so" => "Somalia",
		"za" => "South Africa",
		"es" => "Spain",
		"lk" => "Sri Lanka",
		"sh" => "St. Helena",
		"pm" => "St. Pierre and Miquelon",
		"sd" => "Sudan",
		"sr" => "Suriname",
		"sj" => "Svalbard and Jan Mayen Islands",
		"sz" => "Swaziland",
		"se" => "Sweden",
		"ch" => "Switzerland",
		"sy" => "Syria",
		"tw" => "Taiwan",
		"tj" => "Tajikistan",
		"tz" => "Tanzania",
		"th" => "Thailand",
		"tg" => "Togo",
		"tk" => "Tokelau",
		"to" => "Tonga",
		"tt" => "Trinidad and Tobago",
		"tn" => "Tunisia",
		"tr" => "Turkey",
		"tm" => "Turkmenistan",
		"tc" => "Turks and Caicos Islands",
		"tv" => "Tuvalu",
		"ug" => "Uganda",
		"ua" => "Ukraine",
		"ae" => "United Arab Emirates",
		"uk" => "United Kingdom",
		"us" => "United States",
		"uy" => "Uruguay",
		"um" => "US Minor Outlying Islands",
		"uz" => "Uzbekistan",
		"vu" => "Vanuatu",
		"va" => "Vatican City State (Holy See)",
		"ve" => "Venezuela",
		"vn" => "Viet Nam",
		"vg" => "Virgin Islands (British)",
		"vi" => "Virgin Islands (US)",
		"wf" => "Wallis and Futuna Islands",
		"eh" => "Western Sahara",
		"ye" => "Yemen",
		"zr" => "Zaire",
		"zm" => "Zambia",
		"zw" => "Zimbabwe",
		);

	return $countries;
	}
	//return country code
	function country_by_code($code){
		$c_array = self::countries();
		if (isset($c_array[$code])) {
			return $c_array[$code];
		}
		else return '';
	}
	//creates an array that's used for profile title select boxes
	function profile_titles(){
	 	global $lang_cs_profile;

		foreach(cpgTool::profile_title_array() as $value){
			$title["$value"] = $lang_cs_profile["$value"];
		}
		return $title;
	}
	function cpg_shop_config_set($name,$value){
		global $CONFIG;

		//$value = addslashes($value);

		if ($CONFIG[$name] === $value) {
			return;
		}

		$sql = "UPDATE {$CONFIG['TABLE_CS_CONFIG']} SET value = '$value' WHERE name = '$name'";
		cpg_db_query($sql);

		if ($CONFIG['log_mode'] != 0) {
			log_write("Setting for '$name' changed from '{$CONFIG[$name]}' to '$value' by user " . USER_NAME, CPG_CONFIG_LOG);
		}

		$CONFIG[$name] = $value;

	}
	//if a price is used in a price set, return true
	function check_if_price_used($id){
		global $CONFIG;
		$rowset = cpgDB::fetchRowset("SELECT price_array FROM `{$CONFIG['TABLE_CS_PRICESET']}`;");
		foreach ($rowset as $current_price_set_data){
			$current_price_array = cpgTool::decode_data($current_price_set_data['price_array']);
			$current_price[]= $current_price_array[0];
		}
		if (in_array($id, $current_price)) {
			return true;
		}
		return false;
	}
	//if an option is used in an option set, return true
	function check_if_option_used($id){
		global $CONFIG;
		$rowset = cpgDB::fetchRowset("SELECT option_array FROM `{$CONFIG['TABLE_CS_OPTIONSET']}`;");
		foreach ($rowset as $current_option_set_data){
			$current_option_array = cpgTool::decode_data($current_option_set_data['option_array']);
			$current_option[]= $current_option_array[0];
		}
		if (in_array($id, $current_option)) {
			return true;
		}
		return false;
	}
	//here's the customers title
	function profile_title_array(){
		return array('mr','mrs');
	}
	//here the additional profile entries get defined
	function profile_definition_array(){
		return array(	'title',
						'surename',
						'lastname',
						'street',
						'city',
						'zip',
						'state',
						'phone',
						'country'
					);
	}
	//here the used gateways are listed, it's the name from the sql
	function gateway_definition_array(){
		return array(	'paypal',
						'wire',
						'cod'
					);
	}
	//here the used delivery methods are listed, it's the name from the sql
	//don't resort as standard need s to be 0, add new methods to the end
	function delivery_definition_array(){
		return array(	'standard',
						'express',
						'ups',
						'pickup'
					);
	}
	//returns an array with the enabled gateways or delivery methods - $default is used to simulate the CONFIG array setup of gateways and delivery - so eg. countries can be passed through this function, too
	//added isship -> here I transmit the cart_is_ship result... if false we can't show cod
	function used_gateway_delivery_array($array, $default=false, $isship=true){
		global $CONFIG, $lang_cs_cart, $currency_symbol;

		if($default){
			$work_array = $default;
		} else {
			$work_array = $CONFIG;
		}

		$counter = 1;
		foreach($array as $key => $value){
			$key = 'cpgshop_'.$value.'_enable';
			$key_fee_enable = 'cpgshop_'.$value.'_fee_enable';
			$key_fee = 'cpgshop_'.$value.'_fee';
			$key_override = 'cpgshop_'.$value.'_override';

			if($work_array["$key"]) {
				//cod check -> if cart isship, cod needs to be disabled
				if ($value == 'cod' && $isship==false) {
					continue;
				}
				//fee enabled
				//set to 0 if not set in config -> Javascript error in gateway select
				if(!is_numeric($work_array["$key_fee"])) $work_array["$key_fee"] = '0';
				if ($work_array["$key_fee_enable"]) {
					$method['fee'][$counter] = $work_array["$key_fee"];
				} else {
					$method['fee'][$counter] = 0;
				}
				//atm used for cod... if override, just standard delivery is possible
				if ($work_array["$key_override"]) {
					$method['override'][$counter] = true;
				} else {
					$method['override'][$counter] = false;
				}
				//add select name to array
				if ($default) {
					$lang = $value;
				} else {
					$lang = $lang_cs_cart["$key"];
				}

				$method['name'][$counter] = $lang.' - '.$currency_symbol[$CONFIG['cpgshop_currency']].' '.cpgTool::price_format($method['fee'][$counter]);
				$method['lang'][$counter] = $lang;
				$method['key'][$counter] = $value;

				$method['js'][$counter] = cpgTool::price_format($work_array["$key_fee"]);
				$counter++;
			}
		}
		return $method;
	}
	// gives back the if clauses for the gateway - delivery dropdown javascript
	function used_gateways_js($override_array){
		//global $CONFIG;
		$counter = true;
		$counter2 = true;
		foreach($override_array as $key => $value){
			if ($value) { //gateway enabled
				if($counter) {
					$counter = false;
					$output .= "id == $key";
				} else {
					$output .= " || id == $key";
				}
			} else {
				if($counter2) {
					$counter2 = false;
					$output2 .= "id == $key";
				} else {
					$output2 .= " || id == $key";
				}
			}
		}

		//we need an antry in output 1+2 so add something just in case -> otherwise we have an empty if clause in the javascript
		if ($output == '') {
			$output = "id == x";
		}
		if ($output2 == '') {
			$output2 = "id == x";
		}
		$return = array ($output, $output2);
		return $return;
	}
	//gets and returns the max additional shipping if set for a price in the cart
	function is_max_weight_fee($cpgshop_cart){
		global $CONFIG;

		$price_array = cpgDB::fetchRowset("SELECT pid, shipping FROM `{$CONFIG['TABLE_CS_PRICE']}` WHERE shipping > 0;");

		if(!$price_array)
			return 0;

		$max = 0;
		foreach($cpgshop_cart as $pid){
			foreach($price_array as $value){
				if($pid['price'] == $value['pid']){
					if ($value['shipping'] > $max) {
						$max = $value['shipping'];
					}
				}
			}
		}
		return $max;
	}
	//returns if an elemnt of the cart needs shipping (or all for download)
	function cart_is_ship($cpgshop_cart){
		global $CONFIG;
		foreach($cpgshop_cart as $pid){
			if(!self::shipping_item($pid['price'])) {
				return 1;
			}
		}
		return 0;
	}
	//for the calc_shipping js... adds the js array keys
	function array_prefix(&$array, $prefix){
		$array = "$prefix:$array";
	}
	//generates an alnum code
	function make_code($lenth = 25) {
		// makes a random alpha numeric string of a given lenth
		$aZ09 = array_merge(range('A', 'Z'), range('a', 'z'),range(0, 9));
		$out ='';
		for($c=0;$c < $lenth;$c++) {
			$out .= $aZ09[mt_rand(0,count($aZ09)-1)];
		}
		return $out;
	}
	//returns the granted discount and currency in an array, needs $cpgshop->profile
	function calculate_discount($cpgshop_cart, $cpgshop_profile){
		global $CONFIG;

		//if we call this function from the order control panel, all calc has already been done and in profile we gave the calculation
		if($cpgshop_profile['discount']['set']){
			return $cpgshop_profile['discount']['value'];
		}
		//sre discounts enabled, if yes, is the min basket size reached?
		if(!$CONFIG['cpgshop_discount_enable'] && cpgTool::price_all($cpgshop_cart) >= $CONFIG['cpgshop_discount_min_basket'])
			return false;

		$total = self::price_all($cpgshop_cart);

		switch($CONFIG['cpgshop_discount_enable']){
			case 1:
				//number of items purcheased
				if(count($cpgshop_cart) >= $CONFIG['cpgshop_discount_trigger']){
					//calc discount
					//if it's a percentage
					if(strpos($CONFIG['cpgshop_discount_value'],'%')){
						$discount['value'] = self::price_all($cpgshop_cart)*(int)$CONFIG['cpgshop_discount_value']/100;
						$discount['currency'] = $CONFIG['cpgshop_currency'];
					} else {
						//it's a fix amount (just return the CONFIG value)
						$discount['value'] = $CONFIG['cpgshop_discount_value'];
						$discount['currency'] = $CONFIG['cpgshop_currency'];
					}
				}
				break;
			case 2:
				//certain amount spent
				if($total >= $CONFIG['cpgshop_discount_trigger']){
					//calc discount
					//if it's a percentage
					if(strpos($CONFIG['cpgshop_discount_value'],'%')){
						$discount['value'] = $total*(int)$CONFIG['cpgshop_discount_value']/100;
						$discount['currency'] = $CONFIG['cpgshop_currency'];
					} else {
						//it's a fix amount (just return the CONFIG value)
						$discount['value'] = $CONFIG['cpgshop_discount_value'];
						$discount['currency'] = $CONFIG['cpgshop_currency'];
					}
				}

				break;
			case 3:
				//discount code
				if(!$cpgshop_profile['discount']['code']) //kein code im cookie gespeichert
					return false;
				//verify the code in the db
				$result = cpgDB::fetchRow("SELECT did, discount, currency, expires, created FROM {$CONFIG['TABLE_CS_DISCOUNT']} WHERE number='".$cpgshop_profile['discount']['code']."' AND valid='1';");
				if($result && self::discount_expired($result['expires'], $result['created'])){
					$discount['value'] = $result['discount'];
					$discount['currency'] = $result['currency'];
				}
				break;
			default:
				return false;
		}
		//discount can max be the value in basket
		if (($total-$discount['value'])<0) {
			$discount['value'] = $total;
		}
		return $discount;
	}
	//check if the discount is expired
	function discount_expired($expires, $created){
		if($expires=='0') {
			return 99999;
		}elseif(($expires-localised_timestamp()) < 0){
			return false; //expired
		}  {
			return ceil(($expires-$created)/24/60/60);
		}
	}
	//returns the included tax
	function calculate_tax($total){
		global $CONFIG;

		$tax = $total*(int)$CONFIG['cpgshop_tax_fee']/100;
		return $tax;
	}
	//creates a download directory for the user, copies index, htaccess and htpasswd
	function ipn_download_dir($uid, $oid, $overwrite_dir = false )
	{
		global $CONFIG, $ERROR, $lang_cpgshop_ipn, $cpg_udb;
		//now create a download directory
		//first test if dir 'albums/downloads exists'
		if (!is_dir($CONFIG['fullpath'].'downloads')) {
			$cpg_umask = umask(0);
			@mkdir($CONFIG['fullpath'].'downloads',octdec($CONFIG['default_dir_mode']));
			umask($cpg_umask);
			unset($cpg_umask);
		}

		//then create the dir for the user user-id_order-id
		//but first do some checks - safe mode enabled? downloads dir exists - if not create
		if (!defined('SILLY_SAFE_MODE')) {
			$filepath = 'downloads' . DS . $uid . '_' . $oid;
			$dest_dir = $CONFIG['fullpath'] . $filepath;
			if (!is_dir($dest_dir)) {
				mkdir($dest_dir, octdec($CONFIG['default_dir_mode']));
				if (!is_dir($dest_dir)) {
					//couldn't create dir
					$ERROR = $lang_cpgshop_ipn['ipn_download_err_mkdir'];
					return false;
				}
				//redundant but... hmmm
				@chmod($dest_dir, octdec($CONFIG['default_dir_mode'])); //silence the output in case chmod is disabled


			} elseif (!$overwrite_dir) { //directory exists
				return false;
			}
			$dest_dir .= DS;
			$filepath .= DS;

			//create random password... we use the users username for the htpasswd
			$clear_txt_password = self::ipn_gen_passwd(8);


			//if server os is windows, then we have to use plain passwords, *nix we need to crypt
			//so do the OS check now and then use wether crypted or plain pwd
			$htpasswd_path = getcwd() . DS . $dest_dir;

			$cage_SERVER = Inspekt::makeServerCage();
			if (eregi("win",php_uname())) { //win
				$password = $clear_txt_password;
			} else { //*nix))
				$password = crypt($clear_txt_password, base64_encode($clear_txt_password));
			}

			$htaccess = cpgDB::fetchRow("SELECT text FROM `{$CONFIG['TABLE_CS_DOCS']}` WHERE name='htaccess';");
			//placeholder <-> path
			$template_vars = array(
				'{HTPASSWD_PATH}' => $htpasswd_path.'.htpasswd',
			);
			$htaccess = html_entity_decode(strtr($htaccess['text'], $template_vars));

			//get user_email and user name - for later email and htpasswd
			$user_email = $cpg_udb->get_user_infos($uid);


			//write htpasswd
			$fp = fopen($dest_dir . '.htpasswd', 'w');
			fwrite($fp, $user_email['user_name'].':'.$password);
			fclose($fp);

			//write htaccess
			$fp = fopen($dest_dir . '.htaccess', 'w');
			fwrite($fp, $htaccess);
			fclose($fp);

			//write an index.html
			$fp = fopen($dest_dir . 'index.html', 'w');
			fwrite($fp, " ");
			fclose($fp);

			//check if all worked
			if (is_file($dest_dir . 'index.html') && is_file($dest_dir . '.htpasswd') && is_file($dest_dir . '.htaccess')) {

				$time = localised_timestamp();
				$results = cpg_db_query ("UPDATE {$CONFIG['TABLE_CS_ORDER']} SET dtime='".$time."', dpwd='".self::encode_data($clear_txt_password)."', sentd='1' WHERE oid='".$oid."';");
				self::ipn_send_password($uid, $oid);

				$ERROR = $lang_cpgshop_ipn['ipn_download_ok'];
				return true;
			} else {
				$ERROR = $lang_cpgshop_ipn['ipn_download_err_noindex'];
				return false;
			}

		} else {
			//email admin safe mode restrictions and die
			$ERROR = $lang_cpgshop_ipn['ipn_download_err_safemode'];
			return false;
		}


	}
	//generates a htpasswd password
	function ipn_gen_passwd ($length = 8)
	{
		//possible chars
		$possible = "0123456789-_bcdfghjkmnpqrstvwxyz";
		$password = "";
		$i = 0;

		// add random characters to $password until $length is reached
		while ($i < $length) {
			$char = substr($possible, mt_rand(0, strlen($possible)-1), 1);
			// don't use if already in the password
			if (!strstr($password, $char)) {
				$password .= $char;
				$i++;
			}
		}
		return $password;
	}
	//sends the password
	//function ipn_send_password($html_message, $txt_message, $subject, $password, $user_info, $user_email, $user_name, $oid, $order_hash)
	function ipn_send_password($uid, $oid)
		{
		global $CONFIG, $lang_cs_profile, $cpg_udb;

		require_once('include'.DS.'mailer.inc.php');

		//get templates
		$result = cpgDB::runQuery("SELECT name, text FROM `{$CONFIG['TABLE_CS_DOCS']}` WHERE name LIKE 'email_password_user_%' LIMIT 3;");
		while ( ($row = mysql_fetch_assoc($result)) ) {
			$MAIL[$row['name']] = $row['text'];
		}
		mysql_free_result($result);
		//get user info --> from the order address table
		$user_info = self::get_user_info($uid);
		//user email and user name
		$user_email = $cpg_udb->get_user_infos($uid);
		//fetch order hash
		$order_hash = cpgDB::fetchRow("SELECT hash, dpwd FROM `{$CONFIG['TABLE_CS_ORDER']}` WHERE oid='".$oid."' LIMIT 1;");

		$template_vars = array(
		'{PASSWORD}' => self::decode_data($order_hash['dpwd']),
		'{TITLE}' => $lang_cs_profile["{$user_info['title']}"], //$user_info['title'],
		'{USER_NAME}' => $user_email['user_name'],
		'{NAME}' => $user_info['surename']. ' ' . $user_info['lastname'],
		'{SITENAME}' => $CONFIG['gallery_name'],
		'{LINK}' => $CONFIG['ecards_more_pic_target']."index.php?file=cpgshop/cpgshop_cart&page=process&order=".$oid."&hash=".$order_hash['hash'],
		);
		$html_mail=cpgTemplate::set(html_entity_decode($MAIL['email_password_user_html']), $template_vars);
		$txt_mail=cpgTemplate::set(html_entity_decode($MAIL['email_password_user_txt']), $template_vars);

		if(self::cpgshop_mail($user_email['user_email'], $MAIL['email_password_user_subj'], $html_mail, 'text/html','','',$txt_mail )) {
			return true;
		}
		return false;
	}
	//locks the download dir
	function lock_download_dir($uid, $oid)
	{
		global $CONFIG;

		$filepath = 'downloads/' . $uid . '_' . $oid;
		$dest_dir = $CONFIG['fullpath'] . $filepath . "/";
		if (is_dir($dest_dir)) {
				//write htaccess
				$fp = fopen($dest_dir . '.htaccess', 'w');
			fwrite($fp, "Order deny,allow\nDeny from all");
				fclose($fp);
				return true;

		}
		return false;
	}
	//cleans the sownload dirs after a certain time (CONFIG setting)
	function download_dir_springbreak($uid, $oid)
	{
		global $CONFIG;

		$filepath = 'downloads/' . $uid . '_' . $oid;
		$dest_dir = $CONFIG['fullpath'] . $filepath . "/";
		if (is_dir($dest_dir)) {
			if (self::download_dir_del($dest_dir)) {
				return true;
			}
		}
		return false;
	}
	//deletes the download dir
	function download_dir_del($path)
	{
		if (is_dir($path)) {
			if ($handle = opendir($path)) {
				while (false !== ($file = readdir($handle))) {
					if ($file != '.' && $file != '..') {
						unlink($path."/".$file);
					}
				}
				closedir($handle);
				rmdir($path);
				return true;
			}
		}
		return;
	}
	//mails status changes to the user
	//awaits teh template name without the ending _html or _txt eg. state_change_paid
	function email_state_change($user_id, $order_id, $template){
		global $CONFIG, $cpg_udb;

		//is emailing state changes enabled?
		if(!$CONFIG['cpgshop_states_email'])
			return false;

		require_once('include'.DS.'mailer.inc.php');
		//billing address
		$user_data = cpgTool::get_user_info($user_id);
		//email, username
		$user_info = $cpg_udb->get_user_infos($user_id);
		//fetch the template
		$result = cpgDB::fetchRowset("SELECT name, text FROM `{$CONFIG['TABLE_CS_DOCS']}` WHERE name LIKE'" . $template . "%';");
		foreach ($result as $key => $array){
			$MAIL[$array['name']] = $array['text'] ;
		}

		$user_title = $lang_cs_profile["{$user_data['title']}"];

		$template_vars = array(
		'{TITLE}' => $lang_cs_profile["{$user_data['title']}"], //$user_info['title'],
		'{ORDER_ID}' => $order_id,
		'{USER_NAME}' => $user_info['user_name'],
		'{LASTNAME}' => $user_data['lastname'],
		'{SURENAME}' => $user_data['surename'],
		'{SITENAME}' => $CONFIG['gallery_name'],
		'{LINK}' => $CONFIG['ecards_more_pic_target']."index.php?file=cpgshop/cpgshop_cart&page=history",
		);
		$html_mail=cpgTemplate::set(html_entity_decode($MAIL[$template.'_html']), $template_vars);
		$txt_mail=cpgTemplate::set(html_entity_decode($MAIL[$template.'_txt']), $template_vars);

		$result = self::cpgshop_mail($user_info['user_email'], $MAIL[$template.'_subj'], $html_mail, 'text/html','','',$txt_mail);
		return $result;
	}

	// Custom mail function
	function cpgshop_mail($to, $subject, $msg_body = '', $type = 'text/plain', $sender_name = '', $sender_email = '', $msg_body_plaintext = '', $attachment = '', $attachment_filename = '')
	{
		global $CONFIG, $lang_charset, $HTML_SUBST;

		// makeshift plaintext if not set
		if (!$msg_body_plaintext){
			$msg_body_plaintext = strip_tags($msg_body);
		}

		// send mails to ALL admins - not bridged only
		if ($to == 'admin') {
			if (UDB_INTEGRATION == 'coppermine') {
				$to = array($CONFIG['gallery_admin_email']);
				$result = cpg_db_query("SELECT user_email FROM {$CONFIG['TABLE_USERS']} WHERE user_group = 1");
				while ($row = mysql_fetch_assoc($result)) {
					if (!empty($row['user_email'])) {
						$to[] = $row['user_email'];
					}
				}
				$to = array_unique($to);
			} else {
				$to = array($CONFIG['gallery_admin_email']);
			}
		} else {
			$to = array($to);
		}
		$to = CPGPluginAPI::filter('cpg_mail_to_email', $to);

		if ($sender_name == '') {
			$sender_name = $CONFIG['gallery_name'];
		}

		if ($sender_email == '') {
			$sender_email = $CONFIG['gallery_admin_email'];
		}

		$sender_email = CPGPluginAPI::filter('cpg_mail_sender_email', $sender_email);

		$sender_name = strtr($sender_name, array_flip($HTML_SUBST));

		$charset = $CONFIG['charset'] == 'language file' ? $lang_charset : $CONFIG['charset'];

		$mail = new cpg_PHPmailer();

		//mod email attachments
		if($attachment_filename != '' && $attachment != '')	{
			$mail->AddStringAttachment($attachment, $attachment_filename );
		}
		//mod end


		if ($CONFIG['smtp_host']) {

			$mail->IsSMTP();
			$mail->Host = $CONFIG['smtp_host'];

			if ($CONFIG['smtp_username']) {
				$mail->SMTPAuth = true;
				$mail->Username = $CONFIG['smtp_username'];
				$mail->Password = $CONFIG['smtp_password'];
			} else {
				$mail->SMTPAuth = false;
			}

		} else {
			$mail->IsMail();
		}

		$mail->IsHTML(true);

		foreach ($to as $email) {
			$mail->AddAddress($email);
		}

		$mail->From = $sender_email;
		$mail->FromName = $sender_name;
		$mail->Subject = $subject;
		$mail->Body = $msg_body;
		$mail->AltBody = $msg_body_plaintext;
		$mail->CharSet = $charset;

		if ($CONFIG['smtp_host'] && $CONFIG['log_mode'] == CPG_LOG_ALL) {
			$mail->SMTPDebug = 2;
			ob_start();
		}

		$result = $mail->Send();

		if ($CONFIG['smtp_host'] && $CONFIG['log_mode'] == CPG_LOG_ALL) {
			$log = ob_get_clean();
			log_write($log, CPG_MAIL_LOG);
		}

		return $result;
	}

	//Send the order confirm mail _ resend the order confirm mail (backend)
	function cpgshop_order_confirmation_mail($user_id, $oid, $cart, $profile, $to_admin = true){
		global $CONFIG, $cpg_udb, $lang_cs_profile, $lang_date, $lang_cs_cart;

		$user_data = self::get_user_info($user_id);
		$user_info = $cpg_udb->get_user_infos($user_id);

		//send the emails - user and admin (attach invoice and billing info)
		$result = cpgDB::runQuery("SELECT name, text FROM `{$CONFIG['TABLE_CS_DOCS']}` WHERE name LIKE 'email_checkout_%';");
		while ( ($row = mysql_fetch_assoc($result)) ) {
			$MAIL[$row['name']] = $row['text'];
		}
		mysql_free_result($result);

		$billing_country = cpgTool::country_by_code($user_data['country']);
		$billing_user_title = $lang_cs_profile["{$user_data['title']}"];
		$billing_address_html = "{$billing_user_title}<br>{$user_data['surename']} {$user_data['lastname']}<br>{$user_data['street']}<br>{$user_data['zip']} {$user_data['city']}<br>{$user_data['state']} {$billing_country}";
		//addition for the different pyment methods
		switch($profile['gateway']['method']){
			case ('paypal'):
				$payment_info_html = $payment_info_txt = $lang_cs_cart['email_paypal_info'];
				break;
			case ('wire'):
				$billing_info_array = array(
					$lang_cs_cart['wire_routing'].':' 		=> html_entity_decode($CONFIG['cpgshop_wire_routing']),
					$lang_cs_cart['wire_account'].':' 		=> html_entity_decode($CONFIG['cpgshop_wire_account']),
					$lang_cs_cart['wire_bank'].':' 			=> html_entity_decode($CONFIG['cpgshop_wire_bank']),
					$lang_cs_cart['wire_bank_address'].':' 	=> html_entity_decode($CONFIG['cpgshop_wire_bank_address']),
					$lang_cs_cart['wire_swift'].':'	 		=> html_entity_decode($CONFIG['cpgshop_wire_swift']),
				);
				$payment_info_html .= "</td></tr><tr><td><table width=\"100%\"align=\"center\">";
				$payment_info_html .= "<tr><td colspan=\"2\">{$lang_cs_cart['email_wire_info']}</td></tr>";
				$payment_info_txt .= $lang_cs_cart['email_wire_info']."\n";
				foreach($billing_info_array as $key => $data){
					if($key)
						$payment_info_html .= "<tr><td padding=\"10px\" align=\"left\">{$key}</td><td width=\"70%\">{$data}</td></tr>\n";
						$payment_info_txt .= "{$key}: {$data}\n";
				}
				$payment_info_html .= "</table></td></tr><tr><td class=\"thank_you\">";
				break;
			case ('cod'):
				$payment_info_html = $payment_info_txt = $lang_cs_cart['email_cod_info'];
				break;
			default:
			;
		} // switch

		if($CONFIG['cpgshop_show_myorders']) {
			$link_txt = $CONFIG['ecards_more_pic_target']."index.php?file=cpgshop/cpgshop_cart&page=history&display=view_act&order=".$oid;
			$link_html = HTMLElement::link($link_txt,$lang_cs_cart['view_order_information']);
		}
		//create the invoice txt+html
		$cart_html = HTMLelement::prev_cart($cart, $profile, 'pdf');
		$cart_txt = HTMLelement::prev_cart($cart, $profile, 'text');
		//send email to customer
		$html_mail = cpgTemplate::set(html_entity_decode($MAIL['email_checkout_user_html']), array(
			'{DATE}'				=>	localised_date(-1, $lang_date['register']),
			'{CUSTOMER_ADDRESS}'	=>	$billing_address_html,
			'{SITENAME}'			=> 	$CONFIG['gallery_name'],
			'{TITLE}'				=>	$billing_user_title,
			'{LASTNAME}'			=>	$user_data['lastname'],
			'{ORDER_ID}'			=> 	$oid,
			'{PAYMENT}'				=>	$payment_info_html,
			'{LINK}'				=>	$link_html,
			'{SHOP_ADDRESS}'		=>	html_entity_decode($MAIL['email_checkout_address_html']),
			'{CART}'				=>	$cart_html,
		));
		$txt_mail = cpgTemplate::set(html_entity_decode($MAIL['email_checkout_user_txt']), array(
			'{DATE}'				=>	localised_date(-1, $lang_date['register']),
			'{CUSTOMER_ADDRESS}'	=>	str_replace("<br>", "\n", $billing_address_html),
			'{SITENAME}'			=> 	$CONFIG['gallery_name'],
			'{TITLE}'				=>	$billing_user_title,
			'{LASTNAME}'			=>	$user_data['lastname'],
			'{ORDER_ID}'			=> 	$oid,
			'{PAYMENT}'				=>	$payment_info_txt,
			'{LINK}'				=>	$link_txt,
			'{SHOP_ADDRESS}'		=>	html_entity_decode($MAIL['email_checkout_address_txt']),
			'{CART}'				=>	$cart_txt,
		));

		require_once('include'.DS.'mailer.inc.php');
		if($CONFIG['cpgshop_pdf_invoice']){
			require_once('plugins'.DS.'cpgshop'.DS.'libs'.DS.'pdf'.DS.'dompdf_config.inc.php');

			$pdf_mail = cpgTemplate::set(html_entity_decode($MAIL['email_checkout_user_pdf']), array(
				'{DATE}'				=>	localised_date(-1, $lang_date['register']),
				'{CUSTOMER_ADDRESS}'	=>	$billing_address_html,
				'{SITENAME}'			=> 	$CONFIG['gallery_name'],
				'{TITLE}'				=>	$billing_user_title,
				'{LASTNAME}'			=>	$user_data['lastname'],
				'{ORDER_ID}'			=> 	$oid,
				'{PAYMENT}'				=>	'',
				'{SHOP_ADDRESS}'		=>	html_entity_decode($MAIL['email_checkout_address_html']),
				'{CART}'				=>	$cart_html,
			));

			$dompdf = new DOMPDF();
			$dompdf->load_html($pdf_mail);
			$dompdf->render();
			$pdf_mail = $dompdf->output();

			$result = self::cpgshop_mail($user_info['user_email'], $MAIL['email_checkout_subj_user'], $html_mail, 'text/html','','',$txt_mail, $pdf_mail, $lang_cs_cart['invoice'].".pdf");
		} else {
			$result = self::cpgshop_mail($user_info['user_email'], $MAIL['email_checkout_subj_user'], $html_mail, 'text/html','','',$txt_mail);
		}

		$button_link = $CONFIG['ecards_more_pic_target']."index.php?file=cpgshop/cpgshop_config&amp;page=order&amp;display=view_act&amp;oid=" . $oid  ;
		//if enabled send the email a notification
		if($CONFIG['cpgshop_notify'] && $to_admin){
			$admin_html_mail = cpgTemplate::set(html_entity_decode($MAIL['email_checkout_admin_html']), array(
				'{DATE}'				=>	localised_date(-1, $lang_date['register']),
				'{CUSTOMER_ADDRESS}'	=>	$billing_address_html,
				'{SITENAME}'			=> 	$CONFIG['gallery_name'],
				'{ADMIN_LINK}'			=> 	HTMLElement::link($button_link, $lang_cs_cart['view_order']),
				'{USER_ID}'				=> 	$user_id,
				'{ORDER_ID}'			=> 	$oid,
				'{USER_NAME}'			=> 	USER_NAME,
				'{CART}'				=>	$cart_html,
			));
			$admin_txt_mail = cpgTemplate::set(html_entity_decode($MAIL['email_checkout_admin_txt']), array(
				'{DATE}'				=>	localised_date(-1, $lang_date['register']),
				'{CUSTOMER_ADDRESS}'	=>	str_replace("<br>", "\n", $billing_address_html),
				'{SITENAME}'			=> 	$CONFIG['gallery_name'],
				'{ADMIN_LINK}'			=> 	$button_link,
				'{USER_ID}'				=> 	$user_id,
				'{ORDER_ID}'			=> 	$oid,
				'{USER_NAME}'			=> 	USER_NAME,
				'{CART}'				=>	$cart_txt,
			));
			$result2 = self::cpgshop_mail($CONFIG['cpgshop_notify_email'], $MAIL['email_checkout_subj_admin'], $admin_html_mail, 'text/html','','',$admin_txt_mail);
		}


	return $result;
	}

}
?>